%{
/*
	Calculation  made by T-Satoh
	Ver 0.01 1999.08.29 
	Ver 0.02 1999.08.31 hexΉ
	Ver 0.03 1999.09.01 '.'C
	Ver x.xx            GBApɎ蒼 by akkera102
*/

//---------------------------------------------------------------------------
#include "inc.h"
#include "minix.h"
#include "div_arm.h"

#define YYSTYPE				int
#define yyoverflow						//G[ׂĂ邾Ȃ̂Ŗ{͂悭Ȃ

//---------------------------------------------------------------------------
char    resultBuf[128];
YYSTYPE result;
u8*     lexpos;

//---------------------------------------------------------------------------
void  CalcExec(u8* buf);
char* CalcGetResultBuf();
int   yylex();
int   yyerror(char* msg);


%}

%token	EOL
%token	NUMBER
%token	LP RP
%left	ADDOP SUBOP
%left	MULOP DIVOP MODOP
%right	MINUS
%start	s

%%

s		: expr EOL
			{
				result = $1;
				_Sprintf(resultBuf, "%d", result);
				YYACCEPT;
			}
		;
expr	: expr ADDOP expr
			{ $$ = $1 + $3; }
		| expr SUBOP expr
			{ $$ = $1 - $3; }
		| expr MULOP expr
			{ $$ = $1 * $3; }
		| expr DIVOP expr
			{ $$ =_Div($1, $3);  }
		| expr MODOP expr
			{ $$ =_UMod($1, $3); }
		| SUBOP expr %prec MINUS
			{ $$ = -$2; }
		| LP expr RP
			{ $$ = $2; }
		| NUMBER
			{ $$ = $1; }
		;
%%

//---------------------------------------------------------------------------
void CalcExec(u8* buf)
{
	lexpos = buf;
	yyparse();
}
//---------------------------------------------------------------------------
char* CalcGetResultBuf()
{
	return resultBuf;
}
//---------------------------------------------------------------------------
//
int yylex()
{
	u8 chr;

	//󔒂ǂݔ΂܂
	for(;;)
	{
		chr = *lexpos++;

		if(chr != ' ')
		{
			break;
		}
	}

	switch(chr)
	{
	case '\0': return EOL;
	case '+':  return ADDOP;
	case '-':  return SUBOP;
	case '*':  return MULOP;
	case '/':  return DIVOP;
	case '%':  return MODOP;
	case '(':  return LP;
	case ')':  return RP;

	default:
		if( _IsDigit(chr) == TRUE )
		{
			yylval = 0;

			do
			{
				yylval = 10 * yylval + (chr - '0');
				chr    = *lexpos++;

			} while( _IsDigit(chr) == TRUE );

			lexpos--;
			return NUMBER;
		}
	}

	return chr;
}
//---------------------------------------------------------------------------
int yyerror(char* msg)
{
	_Sprintf(resultBuf, "%s", msg);
	return 0;
}
